# Turn off the brp-python-bytecompile automagic
%global _python_bytecompile_extra 0

Name:       python-rpm-macros
Version:    3.12
Release:    %mkrel 1
Summary:    The common Python RPM macros
Group:      Development/Python
# macros: MIT, compileall2.py: PSFv2
License:    MIT and Python

# Macros:
Source101:      macros.python
Source102:      macros.python-srpm
Source103:      macros.python2
Source104:      macros.python3
Source105:      macros.pybytecompile

# Lua files
Source201:      python.lua

# Python code
%global compileall2_version 0.7.2
Source301:      https://github.com/fedora-python/compileall2/raw/v%{compileall2_version}/compileall2.py
Source302:      import_all_modules.py
%global pathfix_version 1.0.0
Source303:      https://github.com/fedora-python/pathfix/raw/v%{pathfix_version}/pathfix.py
Source304:      clamp_source_mtime.py

# BRP scripts
# This one is from redhat-rpm-config < 190
# A new upstream is forming in https://github.com/rpm-software-management/python-rpm-packaging/blob/main/scripts/brp-python-bytecompile
# But our version is riddled with Fedora-isms
# We might eventually move to upstream source + Fedora patches, but we are not there yet
Source401:      brp-python-bytecompile
# This one is from https://github.com/rpm-software-management/python-rpm-packaging/blob/main/scripts/brp-python-hardlink
# But we don't use a link in case it changes in upstream, there are no "versions" there yet
# This was removed from RPM 4.17+ so we maintain it here instead
Source402:      brp-python-hardlink
# This one is from redhat-rpm-config < 190
# It has no upstream yet
Source403:      brp-fix-pyc-reproducibility

# restore pyX_inc:
Source501:       macros.python-mga

BuildArch:      noarch

# For %%__default_python3_pkgversion used in %%python_provide
# For python.lua
# For compileall2.py
Requires:       python-srpm-macros = %{version}-%{release}
Provides:       python-macros = %{version}-%{release}

%description
This package contains the unversioned Python RPM macros, that most
implementations should rely on.

You should not need to install this package manually as the various
python?-devel packages require it. So install a python-devel package instead.


%package -n python-srpm-macros
Summary:        RPM macros for building Python source packages

%description -n python-srpm-macros
RPM macros for building Python source packages.

%package -n python2-rpm-macros
Summary:        RPM macros for building Python 2 packages
Group:          Development/Python
Requires:       python-srpm-macros
# (tv) it use macros such as %%py_setup from that sub package:
Requires:       python-macros = %{version}-%{release}

%description -n python2-rpm-macros
RPM macros for building Python 2 packages.

%package -n python3-rpm-macros
Summary:        RPM macros for building Python 3 packages
Group:          Development/Python
# For %%__python3 and %%python3
Requires:       python-srpm-macros = %{version}-%{release}
# (tv) it use macros such as %%py_setup and import_all_modules.py from that sub package:
Requires:       python-macros = %{version}-%{release}

%description -n python3-rpm-macros
RPM macros for building Python 3 packages.


%prep
%autosetup -c -T
cp -a %{sources} .

# We want to have shebang in the script upstream but not here so
# the package with macros does not depend on Python.
sed -i '1s=^#!/usr/bin/env python3==' pathfix.py

%build

%install
mkdir -p %{buildroot}%{_rpmmacrodir}
install -m 644 macros.* %{buildroot}%{_rpmmacrodir}

mkdir -p %{buildroot}%{_rpmluadir}/fedora/srpm
install -p -m 644 -t %{buildroot}%{_rpmluadir}/fedora/srpm python.lua

mkdir -p %{buildroot}%{_rpmconfigdir}/redhat
install -m 644 compileall2.py %{buildroot}%{_rpmconfigdir}/redhat/
install -m 644 clamp_source_mtime.py %{buildroot}%{_rpmconfigdir}/redhat/
install -m 644 import_all_modules.py %{buildroot}%{_rpmconfigdir}/redhat/

install -m 644 pathfix.py %{buildroot}%{_rpmconfigdir}/redhat/
install -m 755 brp-* %{buildroot}%{_rpmconfigdir}/redhat/


# We define our own BRPs here to use the ones from the %%{buildroot},
# that way, this package can be built when it includes them for the first time.
# It also ensures that:
#  - our BRPs can execute
#  - if our BRPs affect this package, we don't need to build it twice
%global __brp_python_bytecompile %{buildroot}%{__brp_python_bytecompile}
%global __brp_python_hardlink %{buildroot}%{__brp_python_hardlink}
%global __brp_fix_pyc_reproducibility %{buildroot}%{__brp_fix_pyc_reproducibility}


%check
# no macros in comments
grep -E '^#[^%%]*%%[^%%]' %{buildroot}%{rpmmacrodir}/macros.* && exit 1 || true


%files
%{_rpmmacrodir}/macros.python
%{_rpmmacrodir}/macros.pybytecompile
%{_rpmconfigdir}/redhat/import_all_modules.py
%{_rpmconfigdir}/redhat/pathfix.py

%files -n python-srpm-macros
%{_rpmmacrodir}/macros.python-srpm
%{_rpmmacrodir}/macros.python-mga
%{_rpmconfigdir}/redhat/compileall2.py
%{_rpmconfigdir}/redhat/clamp_source_mtime.py
%{_rpmconfigdir}/redhat/brp-python-bytecompile
%{_rpmconfigdir}/redhat/brp-python-hardlink
%{_rpmconfigdir}/redhat/brp-fix-pyc-reproducibility
%{_rpmluadir}/fedora/srpm/python.lua

%files -n python2-rpm-macros
%{_rpmmacrodir}/macros.python2

%files -n python3-rpm-macros
%{_rpmmacrodir}/macros.python3


%changelog
* Thu Dec 07 2023 wally <wally> 3.12-1.mga10
+ Revision: 2014548
- new version 3.12
- sync with Fedora where appropriate

* Sun Oct 22 2023 wally <wally> 3.10-8.mga10
+ Revision: 2000186
- revert r1998473 'own __pycache__ dir with %%pycached macro'

* Wed Oct 18 2023 wally <wally> 3.10-7.mga10
+ Revision: 1998473
- own __pycache__ dir with %%pycached macro

* Sun Jan 22 2023 wally <wally> 3.10-6.mga9
+ Revision: 1934843
- introduce pathfix.py (will be removed from python in version 3.12)

* Tue Aug 30 2022 wally <wally> 3.10-5.mga9
+ Revision: 1882148
- update python2-rpm-macros and python3-rpm-macros requires to pull correct pkgs

* Sun Apr 10 2022 wally <wally> 3.10-4.mga9
+ Revision: 1848645
- enable macro definitions removed from rpm-mageia-setup
- update __brp_python_bytecompile override

* Sun Apr 10 2022 wally <wally> 3.10-2.mga9
+ Revision: 1848622
- install brp-python-bytecompile scriptlet

* Sat Feb 05 2022 wally <wally> 3.10-1.mga9
+ Revision: 1771603
- new version 3.10 (sync with Fedora where appropriate)
- exclude brp-python-bytecompile for now and leave it to rpm-mageia-setup

* Sun Mar 14 2021 wally <wally> 3.9-7.mga9
+ Revision: 1702508
- update %%__default_python3_version to 3.9

* Sat Mar 13 2021 wally <wally> 3.9-6.mga9
+ Revision: 1702196
- sync with Fedora

* Mon Sep 28 2020 wally <wally> 3.9-5.mga8
+ Revision: 1630985
- define %%__python as python3

* Mon Sep 28 2020 wally <wally> 3.9-4.mga8
+ Revision: 1630981
- disable unversioned python error for now

* Mon Sep 28 2020 wally <wally> 3.9-3.mga8
+ Revision: 1630945
- sync macros.python-srpm with Fedora where appropriate

* Sun Sep 27 2020 guillomovitch <guillomovitch> 3.9-2.mga8
+ Revision: 1630800
- rebuild to fix automatic dependencies

* Sun Sep 27 2020 guillomovitch <guillomovitch> 3.9-1.mga8
+ Revision: 1630750
- new version 3.9

* Thu Feb 20 2020 umeabot <umeabot> 3-11.mga8
+ Revision: 1546297
- Mageia 8 Mass Rebuild

* Sat Feb 01 2020 wally <wally> 3-10.mga8
+ Revision: 1486311
- add pyver macro from rpm-setup to macros.python-mga

* Fri Sep 06 2019 wally <wally> 3-9.mga8
+ Revision: 1437726
- add more strict requires for python-srpm-macros

* Wed Sep 04 2019 wally <wally> 3-8.mga8
+ Revision: 1437124
- turn off the brp-python-bytecompile automagic
- sync with Fedora
- notable changes
  - switch %%python_provide behavior between Python 2 <--> 3
  - use a new module compileall2 for Python byte-compilation

* Sat Jan 12 2019 wally <wally> 3-7.mga7
+ Revision: 1355635
- add %%pypi_source lua scriptlet to srpm macros (from Fedora)

* Thu Sep 20 2018 umeabot <umeabot> 3-6.mga7
+ Revision: 1290006
- Mageia 7 Mass Rebuild

* Tue Aug 15 2017 philippem <philippem> 3-5.mga7
+ Revision: 1140755
- Add --no-deps option to py_install_wheel macros

* Wed Jan 18 2017 philippem <philippem> 3-4.mga6
+ Revision: 1082243
- sync with Fedora
- Add %%py_build_wheel and %%py_install_wheel macros
- Add %%py_build_egg and %%py_install_egg macros
- Allow multiple args to %%py_build/install macros

* Thu Apr 28 2016 tv <tv> 3-3.mga6
+ Revision: 1007123
- restore %%py[23]_inc macros

* Wed Apr 27 2016 tv <tv> 3-2.mga6
+ Revision: 1006861
- make py[23] packages require common python-rpm-macros pkg

* Tue Apr 26 2016 tv <tv> 3-1.mga6
+ Revision: 1006690
- move pybytecompile in %%_rpmconfigdir too
- resync with FC
- rename files like upstream

* Sun Feb 28 2016 wally <wally> 1-3.mga6
+ Revision: 980270
- add conflicts because of files were moved between pkgs

* Sun Feb 28 2016 philippem <philippem> 1-2.mga6
+ Revision: 980214
- change files extension, seems that .macro is mandatory

* Sat Feb 27 2016 philippem <philippem> 1-1.mga6
+ Revision: 980043
- imported package python-rpm-macros

